diff --git a/gcc/toplev.c b/gcc/toplev.c
index c652522..1542618 100644
--- a/gcc/toplev.c
+++ b/gcc/toplev.c
@@ -223,9 +223,9 @@ get_src_pwd (void)
 void
 announce_function (tree decl)
 {
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     {
-      if (rtl_dump_and_exit)
+      if (GCC_OPTION (rtl_dump_and_exit))
 	fprintf (stderr, "%s ",
 		 identifier_to_locale (IDENTIFIER_POINTER (DECL_NAME (decl))));
       else
@@ -395,7 +395,7 @@ wrapup_global_declaration_2 (tree decl)
       bool needed = true;
       node = varpool_get_node (decl);
 
-      if (!node && flag_ltrans)
+      if (!node && GCC_OPTION (flag_ltrans))
 	needed = false;
       else if (node && node->definition)
 	needed = false;
@@ -410,7 +410,7 @@ wrapup_global_declaration_2 (tree decl)
       else if (DECL_COMDAT (decl))
 	needed = false;
       else if (TREE_READONLY (decl) && !TREE_PUBLIC (decl)
-	       && (optimize || !flag_keep_static_consts
+	       && (GCC_OPTION (optimize) || !GCC_OPTION (flag_keep_static_consts)
 		   || DECL_ARTIFICIAL (decl)))
 	needed = false;
 
@@ -469,7 +469,7 @@ check_global_declaration_1 (tree decl)
       && ! DECL_ARTIFICIAL (decl)
       && ! TREE_NO_WARNING (decl)
       && ! TREE_PUBLIC (decl)
-      && (warn_unused_function
+      && (GCC_OPTION (warn_unused_function)
 	  || TREE_SYMBOL_REFERENCED (DECL_ASSEMBLER_NAME (decl))))
     {
       if (TREE_SYMBOL_REFERENCED (DECL_ASSEMBLER_NAME (decl)))
@@ -481,10 +481,10 @@ check_global_declaration_1 (tree decl)
     }
 
   /* Warn about static fns or vars defined but not used.  */
-  if (((warn_unused_function && TREE_CODE (decl) == FUNCTION_DECL)
+  if (((GCC_OPTION (warn_unused_function) && TREE_CODE (decl) == FUNCTION_DECL)
        /* We don't warn about "static const" variables because the
 	  "rcs_id" idiom uses that construction.  */
-       || (warn_unused_variable
+       || (GCC_OPTION (warn_unused_variable)
 	   && TREE_CODE (decl) == VAR_DECL && ! TREE_READONLY (decl)))
       && ! DECL_IN_SYSTEM_HEADER (decl)
       && ! TREE_USED (decl)
@@ -553,7 +553,7 @@ compile_file (void)
   /* Compilation is now finished except for writing
      what's left of the symbol table output.  */
 
-  if (flag_syntax_only || flag_wpa)
+  if (GCC_OPTION (flag_syntax_only) || GCC_OPTION (flag_wpa))
     return;
 
   ggc_protect_identifiers = false;
@@ -568,13 +568,13 @@ compile_file (void)
 
   /* Compilation unit is finalized.  When producing non-fat LTO object, we are
      basically finished.  */
-  if (in_lto_p || !flag_lto || flag_fat_lto_objects)
+  if (GCC_OPTION (in_lto_p) || !GCC_OPTION (flag_lto) || GCC_OPTION (flag_fat_lto_objects))
     {
       /* File-scope initialization for AddressSanitizer.  */
-      if (flag_sanitize & SANITIZE_ADDRESS)
+      if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
         asan_finish_file ();
 
-      if (flag_sanitize & SANITIZE_THREAD)
+      if (GCC_OPTION (flag_sanitize) & SANITIZE_THREAD)
 	tsan_finish_file ();
 
       output_shared_constant_pool ();
@@ -596,7 +596,7 @@ compile_file (void)
 	dwarf2out_frame_finish ();
     #endif
 
-      (*debug_hooks->finish) (main_input_filename);
+      (*debug_hooks->finish) (GCC_OPTION (main_input_filename));
       timevar_pop (TV_SYMOUT);
 
       /* Output some stuff at end of file if nec.  */
@@ -612,7 +612,7 @@ compile_file (void)
      We used to emit an undefined reference here, but this produces
      link errors if an object file with IL is stored into a shared
      library without invoking lto1.  */
-  if (flag_generate_lto)
+  if (GCC_OPTION (flag_generate_lto))
     {
 #if defined ASM_OUTPUT_ALIGNED_DECL_COMMON
       ASM_OUTPUT_ALIGNED_DECL_COMMON (asm_out_file, NULL_TREE,
@@ -628,7 +628,7 @@ compile_file (void)
 #endif
       /* Let linker plugin know that this is a slim object and must be LTOed
          even when user did not ask for it.  */
-      if (!flag_fat_lto_objects)
+      if (!GCC_OPTION (flag_fat_lto_objects))
         {
 #if defined ASM_OUTPUT_ALIGNED_DECL_COMMON
 	  ASM_OUTPUT_ALIGNED_DECL_COMMON (asm_out_file, NULL_TREE,
@@ -648,7 +648,7 @@ compile_file (void)
   /* Attach a special .ident directive to the end of the file to identify
      the version of GCC which compiled this code.  The format of the .ident
      string is patterned after the ones produced by native SVR4 compilers.  */
-  if (!flag_no_ident)
+  if (!GCC_OPTION (flag_no_ident))
     {
       const char *pkg_version = "(GNU) ";
       char *ident_str;
@@ -898,33 +898,33 @@ print_switch_values (print_switch_fn_type print_fn)
 static void
 init_asm_output (const char *name)
 {
-  if (name == NULL && asm_file_name == 0)
+  if (name == NULL && GCC_OPTION (asm_file_name) == 0)
     asm_out_file = stdout;
   else
     {
-      if (asm_file_name == 0)
+      if (GCC_OPTION (asm_file_name) == 0)
 	{
-	  int len = strlen (dump_base_name);
+	  int len = strlen (GCC_OPTION (dump_base_name));
 	  char *dumpname = XNEWVEC (char, len + 6);
 
-	  memcpy (dumpname, dump_base_name, len + 1);
+	  memcpy (dumpname, GCC_OPTION (dump_base_name), len + 1);
 	  strip_off_ending (dumpname, len);
 	  strcat (dumpname, ".s");
-	  asm_file_name = dumpname;
+	  GCC_OPTION (asm_file_name) = dumpname;
 	}
-      if (!strcmp (asm_file_name, "-"))
+      if (!strcmp (GCC_OPTION (asm_file_name), "-"))
 	asm_out_file = stdout;
       else
-	asm_out_file = fopen (asm_file_name, "w");
+	asm_out_file = fopen (GCC_OPTION (asm_file_name), "w");
       if (asm_out_file == 0)
-	fatal_error ("can%'t open %s for writing: %m", asm_file_name);
+	fatal_error ("can%'t open %s for writing: %m", GCC_OPTION (asm_file_name));
     }
 
-  if (!flag_syntax_only)
+  if (!GCC_OPTION (flag_syntax_only))
     {
       targetm.asm_out.file_start ();
 
-      if (flag_record_gcc_switches)
+      if (GCC_OPTION (flag_record_gcc_switches))
 	{
 	  if (targetm.asm_out.record_gcc_switches)
 	    {
@@ -941,7 +941,7 @@ init_asm_output (const char *name)
 	    inform (input_location, "-frecord-gcc-switches is not supported by the current target");
 	}
 
-      if (flag_verbose_asm)
+      if (GCC_OPTION (flag_verbose_asm))
 	{
 	  /* Print the list of switches in effect
 	     into the assembler file as comments.  */
@@ -1013,7 +1013,7 @@ output_stack_usage (void)
       stack_usage += current_function_dynamic_stack_size;
     }
 
-  if (flag_stack_usage)
+  if (GCC_OPTION (flag_stack_usage))
     {
       expanded_location loc
 	= expand_location (DECL_SOURCE_LOCATION (current_function_decl));
@@ -1050,11 +1050,11 @@ output_stack_usage (void)
 	       stack_usage_kind_str[stack_usage_kind]);
     }
 
-  if (warn_stack_usage >= 0)
+  if (GCC_OPTION (warn_stack_usage) >= 0)
     {
       if (stack_usage_kind == DYNAMIC)
 	warning (OPT_Wstack_usage_, "stack usage might be unbounded");
-      else if (stack_usage > warn_stack_usage)
+      else if (stack_usage > GCC_OPTION (warn_stack_usage))
 	{
 	  if (stack_usage_kind == DYNAMIC_BOUNDED)
 	    warning (OPT_Wstack_usage_, "stack usage might be %wd bytes",
@@ -1073,7 +1073,7 @@ open_auxiliary_file (const char *ext)
   char *filename;
   FILE *file;
 
-  filename = concat (aux_base_name, ".", ext, NULL);
+  filename = concat (GCC_OPTION (aux_base_name), ".", ext, NULL);
   file = fopen (filename, "w");
   if (!file)
     fatal_error ("can%'t open %s for writing: %m", filename);
@@ -1199,24 +1199,24 @@ target_supports_section_anchors_p (void)
 static void
 init_alignments (void)
 {
-  if (align_loops <= 0)
-    align_loops = 1;
-  if (align_loops_max_skip > align_loops)
-    align_loops_max_skip = align_loops - 1;
-  align_loops_log = floor_log2 (align_loops * 2 - 1);
-  if (align_jumps <= 0)
-    align_jumps = 1;
-  if (align_jumps_max_skip > align_jumps)
-    align_jumps_max_skip = align_jumps - 1;
-  align_jumps_log = floor_log2 (align_jumps * 2 - 1);
-  if (align_labels <= 0)
-    align_labels = 1;
-  align_labels_log = floor_log2 (align_labels * 2 - 1);
-  if (align_labels_max_skip > align_labels)
-    align_labels_max_skip = align_labels - 1;
-  if (align_functions <= 0)
-    align_functions = 1;
-  align_functions_log = floor_log2 (align_functions * 2 - 1);
+  if (GCC_OPTION (align_loops) <= 0)
+    GCC_OPTION (align_loops) = 1;
+  if (align_loops_max_skip > GCC_OPTION (align_loops))
+    align_loops_max_skip = GCC_OPTION (align_loops) - 1;
+  align_loops_log = floor_log2 (GCC_OPTION (align_loops) * 2 - 1);
+  if (GCC_OPTION (align_jumps) <= 0)
+    GCC_OPTION (align_jumps) = 1;
+  if (align_jumps_max_skip > GCC_OPTION (align_jumps))
+    align_jumps_max_skip = GCC_OPTION (align_jumps) - 1;
+  align_jumps_log = floor_log2 (GCC_OPTION (align_jumps) * 2 - 1);
+  if (GCC_OPTION (align_labels) <= 0)
+    GCC_OPTION (align_labels) = 1;
+  align_labels_log = floor_log2 (GCC_OPTION (align_labels) * 2 - 1);
+  if (align_labels_max_skip > GCC_OPTION (align_labels))
+    align_labels_max_skip = GCC_OPTION (align_labels) - 1;
+  if (GCC_OPTION (align_functions) <= 0)
+    GCC_OPTION (align_functions) = 1;
+  align_functions_log = floor_log2 (GCC_OPTION (align_functions) * 2 - 1);
 }
 
 /* Process the options that have been parsed.  */
@@ -1227,7 +1227,7 @@ process_options (void)
      This can happen with incorrect pre-processed input. */
   debug_hooks = &do_nothing_debug_hooks;
 
-  maximum_field_alignment = initial_max_fld_align * BITS_PER_UNIT;
+  maximum_field_alignment = GCC_OPTION (initial_max_fld_align) * BITS_PER_UNIT;
 
   /* Default to -fdiagnostics-color=auto if GCC_COLORS is in the environment,
      otherwise default to -fdiagnostics-color=never.  */
@@ -1240,45 +1240,45 @@ process_options (void)
      initialization based on the command line options.  This hook also
      sets the original filename if appropriate (e.g. foo.i -> foo.c)
      so we can correctly initialize debug output.  */
-  no_backend = lang_hooks.post_options (&main_input_filename);
+  no_backend = lang_hooks.post_options (&GCC_OPTION (main_input_filename));
 
   /* Some machines may reject certain combinations of options.  */
   targetm.target_option.override ();
 
   /* Avoid any informative notes in the second run of -fcompare-debug.  */
-  if (flag_compare_debug) 
+  if (GCC_OPTION (flag_compare_debug)) 
     diagnostic_inhibit_notes (global_dc);
 
-  if (flag_section_anchors && !target_supports_section_anchors_p ())
+  if (GCC_OPTION (flag_section_anchors) && !target_supports_section_anchors_p ())
     {
       warning (OPT_fsection_anchors,
 	       "this target does not support %qs", "-fsection-anchors");
-      flag_section_anchors = 0;
+      GCC_OPTION (flag_section_anchors) = 0;
     }
 
-  if (flag_short_enums == 2)
-    flag_short_enums = targetm.default_short_enums ();
+  if (GCC_OPTION (flag_short_enums) == 2)
+    GCC_OPTION (flag_short_enums) = targetm.default_short_enums ();
 
   /* Set aux_base_name if not already set.  */
-  if (aux_base_name)
+  if (GCC_OPTION (aux_base_name))
     ;
-  else if (main_input_filename)
+  else if (GCC_OPTION (main_input_filename))
     {
-      char *name = xstrdup (lbasename (main_input_filename));
+      char *name = xstrdup (lbasename (GCC_OPTION (main_input_filename)));
 
       strip_off_ending (name, strlen (name));
-      aux_base_name = name;
+      GCC_OPTION (aux_base_name) = name;
     }
   else
-    aux_base_name = "gccaux";
+    GCC_OPTION (aux_base_name) = "gccaux";
 
 #ifndef HAVE_cloog
-  if (flag_graphite
-      || flag_graphite_identity
-      || flag_loop_block
-      || flag_loop_interchange
-      || flag_loop_strip_mine
-      || flag_loop_parallelize_all)
+  if (GCC_OPTION (flag_graphite)
+      || GCC_OPTION (flag_graphite_identity)
+      || GCC_OPTION (flag_loop_block)
+      || GCC_OPTION (flag_loop_interchange)
+      || GCC_OPTION (flag_loop_strip_mine)
+      || GCC_OPTION (flag_loop_parallelize_all))
     sorry ("Graphite loop optimizations cannot be used (-fgraphite, "
 	   "-fgraphite-identity, -floop-block, "
 	   "-floop-interchange, -floop-strip-mine, -floop-parallelize-all, "
@@ -1286,284 +1286,284 @@ process_options (void)
 #endif
 
   /* One region RA really helps to decrease the code size.  */
-  if (flag_ira_region == IRA_REGION_AUTODETECT)
-    flag_ira_region
-      = optimize_size || !optimize ? IRA_REGION_ONE : IRA_REGION_MIXED;
+  if (GCC_OPTION (flag_ira_region) == IRA_REGION_AUTODETECT)
+    GCC_OPTION (flag_ira_region)
+      = GCC_OPTION (optimize_size) || !GCC_OPTION (optimize) ? IRA_REGION_ONE : IRA_REGION_MIXED;
 
-  if (flag_strict_volatile_bitfields > 0 && !abi_version_at_least (2))
+  if (GCC_OPTION (flag_strict_volatile_bitfields) > 0 && !abi_version_at_least (2))
     {
       warning (0, "-fstrict-volatile-bitfields disabled; "
 	       "it is incompatible with ABI versions < 2");
-      flag_strict_volatile_bitfields = 0;
+      GCC_OPTION (flag_strict_volatile_bitfields) = 0;
     }
 
   /* Unrolling all loops implies that standard loop unrolling must also
      be done.  */
-  if (flag_unroll_all_loops)
-    flag_unroll_loops = 1;
+  if (GCC_OPTION (flag_unroll_all_loops))
+    GCC_OPTION (flag_unroll_loops) = 1;
 
   /* web and rename-registers help when run after loop unrolling.  */
-  if (flag_web == AUTODETECT_VALUE)
-    flag_web = flag_unroll_loops || flag_peel_loops;
+  if (GCC_OPTION (flag_web) == AUTODETECT_VALUE)
+    GCC_OPTION (flag_web) = GCC_OPTION (flag_unroll_loops) || GCC_OPTION (flag_peel_loops);
 
-  if (flag_rename_registers == AUTODETECT_VALUE)
-    flag_rename_registers = flag_unroll_loops || flag_peel_loops;
+  if (GCC_OPTION (flag_rename_registers) == AUTODETECT_VALUE)
+    GCC_OPTION (flag_rename_registers) = GCC_OPTION (flag_unroll_loops) || GCC_OPTION (flag_peel_loops);
 
-  if (flag_non_call_exceptions)
-    flag_asynchronous_unwind_tables = 1;
-  if (flag_asynchronous_unwind_tables)
-    flag_unwind_tables = 1;
+  if (GCC_OPTION (flag_non_call_exceptions))
+    GCC_OPTION (flag_asynchronous_unwind_tables) = 1;
+  if (GCC_OPTION (flag_asynchronous_unwind_tables))
+    GCC_OPTION (flag_unwind_tables) = 1;
 
-  if (flag_value_profile_transformations)
-    flag_profile_values = 1;
+  if (GCC_OPTION (flag_value_profile_transformations))
+    GCC_OPTION (flag_profile_values) = 1;
 
   /* Warn about options that are not supported on this machine.  */
 #ifndef INSN_SCHEDULING
-  if (flag_schedule_insns || flag_schedule_insns_after_reload)
+  if (GCC_OPTION (flag_schedule_insns) || GCC_OPTION (flag_schedule_insns_after_reload))
     warning (0, "instruction scheduling not supported on this target machine");
 #endif
 #ifndef DELAY_SLOTS
-  if (flag_delayed_branch)
+  if (GCC_OPTION (flag_delayed_branch))
     warning (0, "this target machine does not have delayed branches");
 #endif
 
   user_label_prefix = USER_LABEL_PREFIX;
-  if (flag_leading_underscore != -1)
+  if (GCC_OPTION (flag_leading_underscore) != -1)
     {
       /* If the default prefix is more complicated than "" or "_",
 	 issue a warning and ignore this option.  */
       if (user_label_prefix[0] == 0 ||
 	  (user_label_prefix[0] == '_' && user_label_prefix[1] == 0))
 	{
-	  user_label_prefix = flag_leading_underscore ? "_" : "";
+	  user_label_prefix = GCC_OPTION (flag_leading_underscore) ? "_" : "";
 	}
       else
 	warning (0, "-f%sleading-underscore not supported on this target machine",
-		 flag_leading_underscore ? "" : "no-");
+		 GCC_OPTION (flag_leading_underscore) ? "" : "no-");
     }
 
   /* If we are in verbose mode, write out the version and maybe all the
      option flags in use.  */
-  if (version_flag)
+  if (GCC_OPTION (version_flag))
     {
       print_version (stderr, "");
-      if (! quiet_flag)
+      if (! GCC_OPTION (quiet_flag))
 	print_switch_values (print_to_stderr);
     }
 
-  if (flag_syntax_only)
+  if (GCC_OPTION (flag_syntax_only))
     {
-      write_symbols = NO_DEBUG;
-      profile_flag = 0;
+      GCC_OPTION (write_symbols) = NO_DEBUG;
+      GCC_OPTION (profile_flag) = 0;
     }
 
-  if (flag_gtoggle)
+  if (GCC_OPTION (flag_gtoggle))
     {
-      if (debug_info_level == DINFO_LEVEL_NONE)
+      if (GCC_OPTION (debug_info_level) == DINFO_LEVEL_NONE)
 	{
-	  debug_info_level = DINFO_LEVEL_NORMAL;
+	  GCC_OPTION (debug_info_level) = DINFO_LEVEL_NORMAL;
 
-	  if (write_symbols == NO_DEBUG)
-	    write_symbols = PREFERRED_DEBUGGING_TYPE;
+	  if (GCC_OPTION (write_symbols) == NO_DEBUG)
+	    GCC_OPTION (write_symbols) = PREFERRED_DEBUGGING_TYPE;
 	}
       else
-	debug_info_level = DINFO_LEVEL_NONE;
+	GCC_OPTION (debug_info_level) = DINFO_LEVEL_NONE;
     }
 
-  if (flag_dump_final_insns && !flag_syntax_only && !no_backend)
+  if (GCC_OPTION (flag_dump_final_insns) && !GCC_OPTION (flag_syntax_only) && !no_backend)
     {
-      FILE *final_output = fopen (flag_dump_final_insns, "w");
+      FILE *final_output = fopen (GCC_OPTION (flag_dump_final_insns), "w");
       if (!final_output)
 	{
 	  error ("could not open final insn dump file %qs: %m",
-		 flag_dump_final_insns);
-	  flag_dump_final_insns = NULL;
+		 GCC_OPTION (flag_dump_final_insns));
+	  GCC_OPTION (flag_dump_final_insns) = NULL;
 	}
       else if (fclose (final_output))
 	{
 	  error ("could not close zeroed insn dump file %qs: %m",
-		 flag_dump_final_insns);
-	  flag_dump_final_insns = NULL;
+		 GCC_OPTION (flag_dump_final_insns));
+	  GCC_OPTION (flag_dump_final_insns) = NULL;
 	}
     }
 
   /* A lot of code assumes write_symbols == NO_DEBUG if the debugging
      level is 0.  */
-  if (debug_info_level == DINFO_LEVEL_NONE)
-    write_symbols = NO_DEBUG;
+  if (GCC_OPTION (debug_info_level) == DINFO_LEVEL_NONE)
+    GCC_OPTION (write_symbols) = NO_DEBUG;
 
-  if (write_symbols == NO_DEBUG)
+  if (GCC_OPTION (write_symbols) == NO_DEBUG)
     ;
 #if defined(DBX_DEBUGGING_INFO)
-  else if (write_symbols == DBX_DEBUG)
+  else if (GCC_OPTION (write_symbols) == DBX_DEBUG)
     debug_hooks = &dbx_debug_hooks;
 #endif
 #if defined(XCOFF_DEBUGGING_INFO)
-  else if (write_symbols == XCOFF_DEBUG)
+  else if (GCC_OPTION (write_symbols) == XCOFF_DEBUG)
     debug_hooks = &xcoff_debug_hooks;
 #endif
 #ifdef SDB_DEBUGGING_INFO
-  else if (write_symbols == SDB_DEBUG)
+  else if (GCC_OPTION (write_symbols) == SDB_DEBUG)
     debug_hooks = &sdb_debug_hooks;
 #endif
 #ifdef DWARF2_DEBUGGING_INFO
-  else if (write_symbols == DWARF2_DEBUG)
+  else if (GCC_OPTION (write_symbols) == DWARF2_DEBUG)
     debug_hooks = &dwarf2_debug_hooks;
 #endif
 #ifdef VMS_DEBUGGING_INFO
-  else if (write_symbols == VMS_DEBUG || write_symbols == VMS_AND_DWARF2_DEBUG)
+  else if (GCC_OPTION (write_symbols) == VMS_DEBUG || GCC_OPTION (write_symbols) == VMS_AND_DWARF2_DEBUG)
     debug_hooks = &vmsdbg_debug_hooks;
 #endif
   else
     error ("target system does not support the \"%s\" debug format",
-	   debug_type_names[write_symbols]);
+	   debug_type_names[GCC_OPTION (write_symbols)]);
 
   /* We know which debug output will be used so we can set flag_var_tracking
      and flag_var_tracking_uninit if the user has not specified them.  */
-  if (debug_info_level < DINFO_LEVEL_NORMAL
+  if (GCC_OPTION (debug_info_level) < DINFO_LEVEL_NORMAL
       || debug_hooks->var_location == do_nothing_debug_hooks.var_location)
     {
-      if (flag_var_tracking == 1
-	  || flag_var_tracking_uninit == 1)
+      if (GCC_OPTION (flag_var_tracking) == 1
+	  || GCC_OPTION (flag_var_tracking_uninit) == 1)
         {
-	  if (debug_info_level < DINFO_LEVEL_NORMAL)
+	  if (GCC_OPTION (debug_info_level) < DINFO_LEVEL_NORMAL)
 	    warning (0, "variable tracking requested, but useless unless "
 		     "producing debug info");
 	  else
 	    warning (0, "variable tracking requested, but not supported "
 		     "by this debug format");
 	}
-      flag_var_tracking = 0;
-      flag_var_tracking_uninit = 0;
+      GCC_OPTION (flag_var_tracking) = 0;
+      GCC_OPTION (flag_var_tracking_uninit) = 0;
     }
 
   /* The debug hooks are used to implement -fdump-go-spec because it
      gives a simple and stable API for all the information we need to
      dump.  */
-  if (flag_dump_go_spec != NULL)
-    debug_hooks = dump_go_spec_init (flag_dump_go_spec, debug_hooks);
+  if (GCC_OPTION (flag_dump_go_spec) != NULL)
+    debug_hooks = dump_go_spec_init (GCC_OPTION (flag_dump_go_spec), debug_hooks);
 
   /* If the user specifically requested variable tracking with tagging
      uninitialized variables, we need to turn on variable tracking.
      (We already determined above that variable tracking is feasible.)  */
-  if (flag_var_tracking_uninit == 1)
-    flag_var_tracking = 1;
+  if (GCC_OPTION (flag_var_tracking_uninit) == 1)
+    GCC_OPTION (flag_var_tracking) = 1;
 
-  if (flag_var_tracking == AUTODETECT_VALUE)
-    flag_var_tracking = optimize >= 1;
+  if (GCC_OPTION (flag_var_tracking) == AUTODETECT_VALUE)
+    GCC_OPTION (flag_var_tracking) = GCC_OPTION (optimize) >= 1;
 
-  if (flag_var_tracking_uninit == AUTODETECT_VALUE)
-    flag_var_tracking_uninit = flag_var_tracking;
+  if (GCC_OPTION (flag_var_tracking_uninit) == AUTODETECT_VALUE)
+    GCC_OPTION (flag_var_tracking_uninit) = GCC_OPTION (flag_var_tracking);
 
-  if (flag_var_tracking_assignments == AUTODETECT_VALUE)
-    flag_var_tracking_assignments = flag_var_tracking
-      && !(flag_selective_scheduling || flag_selective_scheduling2);
+  if (GCC_OPTION (flag_var_tracking_assignments) == AUTODETECT_VALUE)
+    GCC_OPTION (flag_var_tracking_assignments) = GCC_OPTION (flag_var_tracking)
+      && !(GCC_OPTION (flag_selective_scheduling) || GCC_OPTION (flag_selective_scheduling2));
 
-  if (flag_var_tracking_assignments_toggle)
-    flag_var_tracking_assignments = !flag_var_tracking_assignments;
+  if (GCC_OPTION (flag_var_tracking_assignments_toggle))
+    GCC_OPTION (flag_var_tracking_assignments) = !GCC_OPTION (flag_var_tracking_assignments);
 
-  if (flag_var_tracking_assignments && !flag_var_tracking)
-    flag_var_tracking = flag_var_tracking_assignments = -1;
+  if (GCC_OPTION (flag_var_tracking_assignments) && !GCC_OPTION (flag_var_tracking))
+    GCC_OPTION (flag_var_tracking) = GCC_OPTION (flag_var_tracking_assignments) = -1;
 
-  if (flag_var_tracking_assignments
-      && (flag_selective_scheduling || flag_selective_scheduling2))
+  if (GCC_OPTION (flag_var_tracking_assignments)
+      && (GCC_OPTION (flag_selective_scheduling) || GCC_OPTION (flag_selective_scheduling2)))
     warning (0, "var-tracking-assignments changes selective scheduling");
 
-  if (flag_tree_cselim == AUTODETECT_VALUE)
+  if (GCC_OPTION (flag_tree_cselim) == AUTODETECT_VALUE)
 #ifdef HAVE_conditional_move
-    flag_tree_cselim = 1;
+    GCC_OPTION (flag_tree_cselim) = 1;
 #else
-    flag_tree_cselim = 0;
+    GCC_OPTION (flag_tree_cselim) = 0;
 #endif
 
   /* If auxiliary info generation is desired, open the output file.
      This goes in the same directory as the source file--unlike
      all the other output files.  */
-  if (flag_gen_aux_info)
+  if (GCC_OPTION (flag_gen_aux_info))
     {
-      aux_info_file = fopen (aux_info_file_name, "w");
+      aux_info_file = fopen (GCC_OPTION (aux_info_file_name), "w");
       if (aux_info_file == 0)
-	fatal_error ("can%'t open %s: %m", aux_info_file_name);
+	fatal_error ("can%'t open %s: %m", GCC_OPTION (aux_info_file_name));
     }
 
   if (!targetm_common.have_named_sections)
     {
-      if (flag_function_sections)
+      if (GCC_OPTION (flag_function_sections))
 	{
 	  warning (0, "-ffunction-sections not supported for this target");
-	  flag_function_sections = 0;
+	  GCC_OPTION (flag_function_sections) = 0;
 	}
-      if (flag_data_sections)
+      if (GCC_OPTION (flag_data_sections))
 	{
 	  warning (0, "-fdata-sections not supported for this target");
-	  flag_data_sections = 0;
+	  GCC_OPTION (flag_data_sections) = 0;
 	}
     }
 
 #ifndef HAVE_prefetch
-  if (flag_prefetch_loop_arrays > 0)
+  if (GCC_OPTION (flag_prefetch_loop_arrays) > 0)
     {
       warning (0, "-fprefetch-loop-arrays not supported for this target");
-      flag_prefetch_loop_arrays = 0;
+      GCC_OPTION (flag_prefetch_loop_arrays) = 0;
     }
 #else
-  if (flag_prefetch_loop_arrays > 0 && !HAVE_prefetch)
+  if (GCC_OPTION (flag_prefetch_loop_arrays) > 0 && !HAVE_prefetch)
     {
       warning (0, "-fprefetch-loop-arrays not supported for this target (try -march switches)");
-      flag_prefetch_loop_arrays = 0;
+      GCC_OPTION (flag_prefetch_loop_arrays) = 0;
     }
 #endif
 
   /* This combination of options isn't handled for i386 targets and doesn't
      make much sense anyway, so don't allow it.  */
-  if (flag_prefetch_loop_arrays > 0 && optimize_size)
+  if (GCC_OPTION (flag_prefetch_loop_arrays) > 0 && GCC_OPTION (optimize_size))
     {
       warning (0, "-fprefetch-loop-arrays is not supported with -Os");
-      flag_prefetch_loop_arrays = 0;
+      GCC_OPTION (flag_prefetch_loop_arrays) = 0;
     }
 
   /* The presence of IEEE signaling NaNs, implies all math can trap.  */
-  if (flag_signaling_nans)
-    flag_trapping_math = 1;
+  if (GCC_OPTION (flag_signaling_nans))
+    GCC_OPTION (flag_trapping_math) = 1;
 
   /* We cannot reassociate if we want traps or signed zeros.  */
-  if (flag_associative_math && (flag_trapping_math || flag_signed_zeros))
+  if (GCC_OPTION (flag_associative_math) && (GCC_OPTION (flag_trapping_math) || GCC_OPTION (flag_signed_zeros)))
     {
       warning (0, "-fassociative-math disabled; other options take precedence");
-      flag_associative_math = 0;
+      GCC_OPTION (flag_associative_math) = 0;
     }
 
   /* With -fcx-limited-range, we do cheap and quick complex arithmetic.  */
-  if (flag_cx_limited_range)
-    flag_complex_method = 0;
+  if (GCC_OPTION (flag_cx_limited_range))
+    GCC_OPTION (flag_complex_method) = 0;
 
   /* With -fcx-fortran-rules, we do something in-between cheap and C99.  */
-  if (flag_cx_fortran_rules)
-    flag_complex_method = 1;
+  if (GCC_OPTION (flag_cx_fortran_rules))
+    GCC_OPTION (flag_complex_method) = 1;
 
   /* Targets must be able to place spill slots at lower addresses.  If the
      target already uses a soft frame pointer, the transition is trivial.  */
-  if (!FRAME_GROWS_DOWNWARD && flag_stack_protect)
+  if (!FRAME_GROWS_DOWNWARD && GCC_OPTION (flag_stack_protect))
     {
       warning (0, "-fstack-protector not supported for this target");
-      flag_stack_protect = 0;
+      GCC_OPTION (flag_stack_protect) = 0;
     }
-  if (!flag_stack_protect)
-    warn_stack_protect = 0;
+  if (!GCC_OPTION (flag_stack_protect))
+    GCC_OPTION (warn_stack_protect) = 0;
 
   /* Address Sanitizer needs porting to each target architecture.  */
-  if ((flag_sanitize & SANITIZE_ADDRESS)
+  if ((GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
       && (targetm.asan_shadow_offset == NULL
 	  || !FRAME_GROWS_DOWNWARD))
     {
       warning (0, "-fsanitize=address not supported for this target");
-      flag_sanitize &= ~SANITIZE_ADDRESS;
+      GCC_OPTION (flag_sanitize) &= ~SANITIZE_ADDRESS;
     }
 
   /* Enable -Werror=coverage-mismatch when -Werror and -Wno-error
      have not been set.  */
   if (!global_options_set.x_warnings_are_errors
-      && warn_coverage_mismatch
+      && GCC_OPTION (warn_coverage_mismatch)
       && (global_dc->classify_diagnostic[OPT_Wcoverage_mismatch] ==
           DK_UNSPECIFIED))
     diagnostic_classify_diagnostic (global_dc, OPT_Wcoverage_mismatch,
@@ -1642,9 +1642,9 @@ init_excess_precision (void)
      the front end cannot handle it, flag_excess_precision_cmdline
      will already have been set accordingly in the post_options
      hook.  */
-  gcc_assert (flag_excess_precision_cmdline != EXCESS_PRECISION_DEFAULT);
-  flag_excess_precision = flag_excess_precision_cmdline;
-  if (flag_unsafe_math_optimizations)
+  gcc_assert (GCC_OPTION (flag_excess_precision_cmdline) != EXCESS_PRECISION_DEFAULT);
+  flag_excess_precision = GCC_OPTION (flag_excess_precision_cmdline);
+  if (GCC_OPTION (flag_unsafe_math_optimizations))
     flag_excess_precision = EXCESS_PRECISION_FAST;
   if (flag_excess_precision == EXCESS_PRECISION_STANDARD)
     {
@@ -1704,8 +1704,8 @@ static int
 lang_dependent_init (const char *name)
 {
   location_t save_loc = input_location;
-  if (dump_base_name == 0)
-    dump_base_name = name && name[0] ? name : "gccdump";
+  if (GCC_OPTION (dump_base_name) == 0)
+    GCC_OPTION (dump_base_name) = name && name[0] ? name : "gccdump";
 
   /* Other front-end initialization.  */
   input_location = BUILTINS_LOCATION;
@@ -1713,12 +1713,12 @@ lang_dependent_init (const char *name)
     return 0;
   input_location = save_loc;
 
-  if (!flag_wpa)
+  if (!GCC_OPTION (flag_wpa))
     {
       init_asm_output (name);
 
       /* If stack usage information is desired, open the output file.  */
-      if (flag_stack_usage)
+      if (GCC_OPTION (flag_stack_usage))
 	stack_usage_file = open_auxiliary_file ("su");
     }
 
@@ -1729,7 +1729,7 @@ lang_dependent_init (const char *name)
   /* Do the target-specific parts of the initialization.  */
   lang_dependent_init_target ();
 
-  if (!flag_wpa)
+  if (!GCC_OPTION (flag_wpa))
     {
       /* If dbx symbol table desired, initialize writing it and output the
 	 predefined types.  */
@@ -1829,11 +1829,11 @@ static void
 finalize (bool no_backend)
 {
   /* Close the dump files.  */
-  if (flag_gen_aux_info)
+  if (GCC_OPTION (flag_gen_aux_info))
     {
       fclose (aux_info_file);
       if (seen_error ())
-	unlink (aux_info_file_name);
+	unlink (GCC_OPTION (aux_info_file_name));
     }
 
   /* Close non-debugging input and output files.  Take special care to note
@@ -1843,9 +1843,9 @@ finalize (bool no_backend)
   if (asm_out_file)
     {
       if (ferror (asm_out_file) != 0)
-	fatal_error ("error writing to %s: %m", asm_file_name);
+	fatal_error ("error writing to %s: %m", GCC_OPTION (asm_file_name));
       if (fclose (asm_out_file) != 0)
-	fatal_error ("error closing %s: %m", asm_file_name);
+	fatal_error ("error closing %s: %m", GCC_OPTION (asm_file_name));
     }
 
   if (stack_usage_file)
@@ -1860,10 +1860,10 @@ finalize (bool no_backend)
       ira_finish_once ();
     }
 
-  if (mem_report)
+  if (GCC_OPTION (mem_report))
     dump_memory_report (true);
 
-  if (profile_report)
+  if (GCC_OPTION (profile_report))
     dump_profile_report ();
 
   /* Language-specific end of compilation actions.  */
@@ -1876,7 +1876,7 @@ do_compile (void)
 {
   /* Initialize timing first.  The C front ends read the main file in
      the post_options hook, and C++ does file timings.  */
-  if (time_report || !quiet_flag  || flag_detailed_statistics)
+  if (GCC_OPTION (time_report) || !GCC_OPTION (quiet_flag)  || GCC_OPTION (flag_detailed_statistics))
     timevar_init ();
   timevar_start (TV_TOTAL);
 
@@ -1897,15 +1897,15 @@ do_compile (void)
 	backend_init ();
 
       /* Language-dependent initialization.  Returns true on success.  */
-      if (lang_dependent_init (main_input_filename))
+      if (lang_dependent_init (GCC_OPTION (main_input_filename)))
         {
           /* Initialize yet another pass.  */
 
           ggc_protect_identifiers = true;
 
           init_cgraph ();
-          init_final (main_input_filename);
-          coverage_init (aux_base_name);
+          init_final (GCC_OPTION (main_input_filename));
+          coverage_init (GCC_OPTION (aux_base_name));
           statistics_init ();
           invoke_plugin_callbacks (PLUGIN_START_UNIT, NULL);
 
@@ -1979,14 +1979,14 @@ toplev_main (int argc, char **argv)
 
   initialize_plugins ();
 
-  if (version_flag)
+  if (GCC_OPTION (version_flag))
     print_version (stderr, "");
 
-  if (help_flag)
+  if (GCC_OPTION (help_flag))
     print_plugins_help (stderr, "");
 
   /* Exit early if we can (e.g. -help).  */
-  if (!exit_after_options)
+  if (!GCC_OPTION (exit_after_options))
     do_compile ();
 
   if (warningcount || errorcount || werrorcount)
